import { ApolloLink, FetchResult, NextLink, Observable, Operation } from 'apollo-link';
import { Span, TracerConfiguration } from '@convoy/tracer';
export declare type ErrorAnnotatorFunction = (span: Span, error: Error) => void;
export declare type GraphQLErrorAnnotatorFunction = (span: Span, result: FetchResult) => void;
export default class ApolloLinkTracer extends ApolloLink {
    private service;
    private tracerConfig;
    private name?;
    private networkErrorAnnotator;
    private graphQLErrorAnnotator;
    constructor({service, tracerConfig, name, networkErrorAnnotator, graphQLErrorAnnotator}: {
        service: string;
        tracerConfig: TracerConfiguration;
        name?: string;
        networkErrorAnnotator?: ErrorAnnotatorFunction;
        graphQLErrorAnnotator?: GraphQLErrorAnnotatorFunction;
    });
    request(operation: Operation, forward: NextLink): Observable<{}>;
}
export declare function baseGQLAnnotator(span: Span, result: FetchResult): void;
